clear
clc
fnameinput = ('BALTIC.mat'); %wczytanie zmiennych
DATA = load(fnameinput);

%country = [DATA.de, DATA.dk, DATA.ee, DATA.fi, DATA.lit, DATA.lv, DATA.pl, DATA.ruc, DATA.se];

country = [DATA.dk, DATA.ee, DATA.fi, DATA.de, DATA.lv, DATA.lit, DATA.pl, DATA.ruc, DATA.se];
DATA.TC = 2*(DATA.TC_km + DATA.TC_time/3);
DATA.TRIPS0 = DATA.TRIPS == 0;
DATA.Edu_dummy = dummyvar(DATA.EDU);
DATA.HINC(DATA.ee == 1) = DATA.HINC(DATA.ee == 1)/15.9428;
DATA.HINC = DATA.HINC/1000;

DATA.envbn(isnan(DATA.envbn)) = mean(DATA.envbn(~isnan(DATA.envbn)));

X = [DATA.TRIPS, DATA.dist, DATA.TIME, DATA.TRIPS0, DATA.TC, 2*DATA.TC_km, 2*DATA.TC_time/3, DATA.age, DATA.Edu_dummy, DATA.MALE, DATA.bocc, DATA.HHSIZE, DATA.HHKIDS, DATA.HINC,DATA.envbn];
X = X(DATA.OUT == 0, :);
M = zeros(37,9);
country = country(DATA.OUT == 0, :);
for i = 1:9
   meanX = mean(X(country(:,i) == 1,:))';
   stdX =  std(X(country(:,i) == 1,:))';
   M(1:2:35,i) = meanX;
   M(2:2:36,i) = stdX;
   M(37,i) = sum(country(:,i) == 1);
end

M

% Table for supplement, with descriptive statistics of respondents who
% didn't make any trip
M2 = zeros(35,9);
X = X(:, [1:3, 5:18]);
country = country(X(:,1) == 0,:);
X = X(X(:,1) == 0,:);
for i = 1:9
   meanX = mean(X(country(:,i) == 1,:))';
   stdX =  std(X(country(:,i) == 1,:))';
   M2(1:2:33,i) = meanX;
   M2(2:2:34,i) = stdX;
   M2(35,i) = sum(country(:,i) == 1);
end

M2