clear
clc
fnameinput = ('BALTIC.mat'); %wczytanie zmiennych
DATA = load(fnameinput);

n = 10000; % no. of draws in simluation


country = [DATA.dk, DATA.ee, DATA.fi, DATA.de, DATA.lv, DATA.lit, DATA.pl, DATA.ruc, DATA.se];
DATA.TC = 2*(DATA.TC_km + DATA.TC_time/3);
DATA.Edu_dummy = dummyvar(DATA.EDU);
DATA.HINC(DATA.ee == 1) = DATA.HINC(DATA.ee == 1)/15.9428;
DATA.HINC = DATA.HINC/1000;
DATA.HINC2 = DATA.HINC.^2;
DATA.age = DATA.age/10;
DATA.age2 = DATA.age.^2;
%DATA.bocc(DATA.bocc == -999) = 0;
DATA.envbn(~isnan(DATA.envbn)) = (DATA.envbn(~isnan(DATA.envbn)) - mean(DATA.envbn(~isnan(DATA.envbn))))/std(DATA.envbn(~isnan(DATA.envbn)));
DATA.envbn(isnan(DATA.envbn)) = mean(DATA.envbn(~isnan(DATA.envbn)));

DATA.X = [country, country.*DATA.TC(:,ones(9,1)),  DATA.envbn, DATA.MALE, DATA.HINC, DATA.HINC2, DATA.bocc];

DATA.Z = [country, DATA.envbn, DATA.MALE, DATA.HHKIDS, DATA.age, DATA.age2,DATA.Edu_dummy(:,2:4), DATA.bocc];
DATA.X = DATA.X(DATA.ruo == 0 & DATA.OUT == 0,:);
DATA.Z = DATA.Z(DATA.ruo == 0 & DATA.OUT == 0,:);
DATA.TRIPS0 = DATA.TRIPS == 0;
DATA.TRIPS0 = DATA.TRIPS0(DATA.ruo == 0 & DATA.OUT == 0);
DATA.TRIPS = DATA.TRIPS(DATA.ruo == 0 & DATA.OUT == 0);

%wczytanie parametrw
fnameinput = ('COEF.mat'); %wczytanie zmiennych
Param = load(fnameinput);

b = Param.b;
gammab = Param.gamma;
COV = Param.COV;
gammastd = Param.gammastd;

Adults = [4.266808,1.049334,4.214569,67.211949,1.631876,2.347624,30.518023,0.8*(941873+1716868+4879566)/1000000,7.379407]; % populacja
weight = Adults/sum(Adults,2);

% Calculating CS for one trip and its covariance matrix using delta method
tmp = diag(1./(b(10:18)).^2);
grad = zeros(9,23); 
grad(:,10:18) = tmp;
CS_var = grad*COV*grad';
CS = -1./b(10:18);

%random draws from B, CS and gamma
B = mvnrnd(b', COV, n);
%CSrnd = -1./B(:, 10:18); %- this is more proper, but leads to non-defined std for some variables
CSrnd = mvnrnd(CS', CS_var, n);
G = mvnrnd(gammab', diag(gammastd.^2),n);

CS_all = zeros(n,9);
CS_sim = zeros(n,9);
PARTIAL = zeros(n,9);
% Main loop - it may take some time 
for i = 1:n
    lambda = exp(DATA.X*B(i,:)');
    p = 1 - normcdf(DATA.Z*G(i,:)',0,1);
    fit = p.*lambda;
    mean_fit = [mean(fit(DATA.X(:,1) == 1)),mean(fit(DATA.X(:,2) == 1)),mean(fit(DATA.X(:,3) == 1)),mean(fit(DATA.X(:,4) == 1)),mean(fit(DATA.X(:,5) == 1)),mean(fit(DATA.X(:,6) == 1)),mean(fit(DATA.X(:,7) == 1)),mean(fit(DATA.X(:,8) == 1)),mean(fit(DATA.X(:,9) == 1))];
    CS_all(i, :) = mean_fit.*CSrnd(i,:);
    PARTIALx = fit*B(i,19) - normpdf(DATA.Z*G(i,:)',0,1).*lambda*G(i,10);
    PARTIAL(i,:) = [mean(PARTIALx(DATA.X(:,1) == 1)),mean(PARTIALx(DATA.X(:,2) == 1)),mean(PARTIALx(DATA.X(:,3) == 1)),mean(PARTIALx(DATA.X(:,4) == 1)),mean(PARTIALx(DATA.X(:,5) == 1)),mean(PARTIALx(DATA.X(:,6) == 1)),mean(PARTIALx(DATA.X(:,7) == 1)),mean(PARTIALx(DATA.X(:,8) == 1)),mean(PARTIALx(DATA.X(:,9) == 1))];
    fit = fit + PARTIALx;
    mean_fit = [mean(fit(DATA.X(:,1) == 1)),mean(fit(DATA.X(:,2) == 1)),mean(fit(DATA.X(:,3) == 1)),mean(fit(DATA.X(:,4) == 1)),mean(fit(DATA.X(:,5) == 1)),mean(fit(DATA.X(:,6) == 1)),mean(fit(DATA.X(:,7) == 1)),mean(fit(DATA.X(:,8) == 1)),mean(fit(DATA.X(:,9) == 1))];
    CS_sim(i, :) = mean_fit.*CSrnd(i,:);
end
% First part of Table3
    p = 1 - normcdf(DATA.Z*gammab,0,1);
    lambda = exp(DATA.X*b);
    fit = p.*lambda;
    theta = 1/2.48070;
    u = theta./(theta+lambda);
    %p0 = (1-p) + p.*(gamma(theta).*(u.^theta))./gamma(theta);
    p0 = (u.^theta);
    p0 = (1-p) + p.*p0;
    M = [];
    CS_std = sqrt(diag(CS_var));
for i = 1:9
    tmp = [mean(p(DATA.X(:,i) == 1)); std(p(DATA.X(:,i) == 1)); mean(p0(DATA.X(:,i) == 1)); std(p0(DATA.X(:,i) == 1)); mean(DATA.TRIPS0(DATA.X(:,i) == 1)); std(DATA.TRIPS0(DATA.X(:,i) == 1)); ...
        mean(fit(DATA.X(:,i) == 1)); std(fit(DATA.X(:,i) == 1)); mean(DATA.TRIPS(DATA.X(:,i) == 1)); std(DATA.TRIPS(DATA.X(:,i) == 1)); CS(i); CS_std(i)];
    M = [M, tmp];
    
end
% M has 12 rows
% Second part of the Table 3
M2 = [mean(CSrnd); prctile(CSrnd, 2.5); prctile(CSrnd, 97.5) ; prctile(CSrnd, 0.5); mean(CS_all); prctile(CS_all, 2.5); prctile(CS_all, 97.5) ; prctile(CS_all, 0.5); mean(PARTIAL); prctile(PARTIAL, 2.5); prctile(PARTIAL, 97.5) ; prctile(PARTIAL, 0.5);...
    mean(CS_sim); prctile(CS_sim, 2.5); prctile(CS_sim, 97.5) ; prctile(CS_sim, 0.5) ];
M = [Adults; M];% mean(CS_all,1); std(CS_all); mean(PARTIAL,1); std(PARTIAL); mean(CS_sim,1); std(CS_sim)]; %mean(CS_sim,1) - mean(CS_all,1); (mean(CS_sim,1) - mean(CS_all,1))./mean(CS_all,1) ];
% M has 19 rows
% creating last column of M
tmp = sum(M(2:2:12,:).*weight(ones(6,1),:),2);
tmp2 = sqrt(sum((M(3:2:13,:).*weight(ones(6,1),:)).^2,2));
last = zeros(13,1); 
last(1) = sum(Adults,2);
last(2:2:13) = tmp; 
last(3:2:13) = tmp2;
M = [M, last];

last2 = [mean(sum(CSrnd.*weight(ones(n,1),:),2)); prctile(sum(CSrnd.*weight(ones(n,1),:),2), 2.5); prctile(sum(CSrnd.*weight(ones(n,1),:),2), 97.5) ; prctile(sum(CSrnd.*weight(ones(n,1),:),2), 0.5);mean(sum(CS_all.*weight(ones(n,1),:),2)); prctile(sum(CS_all.*weight(ones(n,1),:),2), 2.5); prctile(sum(CS_all.*weight(ones(n,1),:),2), 97.5) ; prctile(sum(CS_all.*weight(ones(n,1),:),2), 0.5);...
    mean(sum(PARTIAL.*weight(ones(n,1),:),2)); prctile(sum(PARTIAL.*weight(ones(n,1),:),2), 2.5); prctile(sum(PARTIAL.*weight(ones(n,1),:),2), 97.5) ; prctile(sum(PARTIAL.*weight(ones(n,1),:),2), 0.5); ...
    mean(sum(CS_sim.*weight(ones(n,1),:),2)); prctile(sum(CS_sim.*weight(ones(n,1),:),2), 2.5); prctile(sum(CS_sim.*weight(ones(n,1),:),2), 97.5) ; prctile(sum(CS_sim.*weight(ones(n,1),:),2), 0.5)] ;
M2 = [M2, last2];
M = [M; M2];
Adults = [Adults, sum(Adults,2)];
M([18:21, 26:29],:) = M([18:21, 26:29],:).*Adults(ones(8,1),:)/1000; 
M = [M; (M(26,:)- M(18,:));  (M(26,:)- M(18,:))./M(18,:)];
% M = [M; (M(18,:)- M(14,:));  (M(18,:)- M(14,:))./M(14,:)];



% M = [Adults; M; mean(CS_all,1); std(CS_all); mean(PARTIAL,1); std(PARTIAL); mean(CS_sim,1); std(CS_sim)]; %mean(CS_sim,1) - mean(CS_all,1); (mean(CS_sim,1) - mean(CS_all,1))./mean(CS_all,1) ];
% % M has 19 rows
% % creating last column of M
% tmp = sum(M(2:2:18,:).*weight(ones(9,1),:),2);
% tmp2 = sqrt(sum((M(3:2:19,:).*weight(ones(9,1),:)).^2,2));
% last = zeros(19,1); 
% last(1) = sum(Adults,2);
% last(2:2:18) = tmp; 
% last(3:2:19) = tmp2;
% M = [M, last];
% M = [M; (M(18,:)- M(14,:));  (M(18,:)- M(14,:))./M(14,:)];
% Adults = [Adults, sum(Adults,2)];
% M(14,:) = M(14,:).*Adults/1000; 
% M(15,:) = M(15,:).*Adults/1000;
% M(18,:) = M(18,:).*Adults/1000; 
% M(19,:) = M(19,:).*Adults/1000; 
% M(20,:) = M(20,:).*Adults/1000; 

