% Different method of obtaining Partials standard deviations

clear
clc
fnameinput = ('BALTIC.mat'); %wczytanie zmiennych
DATA = load(fnameinput);

country = [DATA.dk, DATA.ee, DATA.fi, DATA.de, DATA.lv, DATA.lit, DATA.pl, DATA.ruc, DATA.se];
country2 = [DATA.dk, DATA.ee, DATA.fi, DATA.de, DATA.lv, DATA.lit, DATA.pl, DATA.ruc1,DATA.ruc2, DATA.se];
DATA.TC = 2*(DATA.TC_km + DATA.TC_time/3);
DATA.Edu_dummy = dummyvar(DATA.EDU);
DATA.HINC(DATA.ee == 1) = DATA.HINC(DATA.ee == 1)/15.9428;
DATA.HINC = DATA.HINC/1000;
DATA.HINC2 = DATA.HINC.^2;
DATA.age = DATA.age/10;
DATA.age2 = DATA.age.^2;
%DATA.bocc(DATA.bocc == -999) = 0;
DATA.envbn(~isnan(DATA.envbn)) = (DATA.envbn(~isnan(DATA.envbn)) - mean(DATA.envbn(~isnan(DATA.envbn))))/std(DATA.envbn(~isnan(DATA.envbn)));
DATA.envbn(isnan(DATA.envbn)) = mean(DATA.envbn(~isnan(DATA.envbn)));

DATA.X = [country2, country.*DATA.TC(:,ones(9,1)),  DATA.envbn, DATA.MALE, DATA.HINC, DATA.HINC2, DATA.bocc];

DATA.Z = [country2, DATA.envbn, DATA.MALE, DATA.HHKIDS, DATA.age, DATA.age2,DATA.Edu_dummy(:,2:4), DATA.bocc];
DATA.X = DATA.X(DATA.ruo == 0 & DATA.OUT == 0,:);
DATA.Z = DATA.Z(DATA.ruo == 0 & DATA.OUT == 0,:);

fnameinput = ('COEF_russia.mat'); %wczytanie zmiennych
Param = load(fnameinput);
b = Param.b;
gamma = Param.gamma;
COV = Param.COV;
gammastd = Param.gammastd;

eX = exp(DATA.X*b);
eX = eX(:,ones(1,12));

q =  normpdf(DATA.Z*gamma,0,1);
q = q(:,ones(1,4));
n = 10000;

B = mvnrnd(b', COV, n);
G = mvnrnd(gamma', diag(gammastd.^2),n);
vec1 = [1:10, 21, 24];
vec2 = [1:10, 12, 16:19]; %14
PARX1 = zeros(n, 24);
PARX2 = zeros(n,19);
for j = 1:n
    b_tmp = B(j,:)';
    g_tmp = G(j,:)';
    eX = exp(DATA.X*b_tmp);
    eX = eX(:,ones(1,12));
    q =  normpdf(DATA.Z*g_tmp,0,1);
    q = q(:,ones(1,4));
    PAR1_con = eX.*b_tmp([11:20, 22:23], ones(size(eX,1),1))'; %Partial derivative for Lambda for continous variables
    PAR2_con = q.*g_tmp([11,13:15],ones(size(eX,1),1))'; %Partial derivative for q for continous variables
     
    PAR1_dummy = [];
    for i = 1:length(vec1)
        X_tmp1 = DATA.X;
        X_tmp2 = DATA.X;
        X_tmp1(:,vec1(i)) = 1;
        X_tmp2(:,vec1(i)) = 0;
        PAR1_dummy = [PAR1_dummy, exp(X_tmp1*b_tmp) - exp(X_tmp2*b_tmp)];
    end
    PAR1 = zeros(size(DATA.X,1),24);
    PAR1(:,vec1) = PAR1_dummy;
    PAR1(:, [11:20, 22:23]) = PAR1_con;
    PARX1(j,:) = mean(PAR1);
    
    PAR2_dummy = [];
    for i = 1:length(vec2)
        Z_tmp1 = DATA.Z;
        Z_tmp2 = DATA.Z;
        Z_tmp1(:,vec2(i)) = 1;
        Z_tmp2(:,vec2(i)) = 0;
        PAR2_dummy = [PAR2_dummy, normcdf(Z_tmp1*g_tmp,0,1) - normcdf(Z_tmp2*g_tmp,0,1)];
    end

    PAR2 = zeros(size(DATA.X,1),19);
    PAR2(:,vec2) = PAR2_dummy;
    PAR2(:, [11,13:15]) = PAR2_con;
    PARX2(j,:) = mean(PAR2);
end
std_b = sqrt(diag(Param.COV));
std_gamma = Param.gammastd;
Rout = cell(24*2 + 19*2,4);
x = [b;gamma];
stdx = [std_b; std_gamma];
stars = cellstr(star_sig(pv(x,stdx)));
Rout(1:2:end,1) = num2cell(x);
Rout(2:2:end,1) = num2cell(stdx);
Rout(1:2:end,2) = stars;
x2 = [mean(PARX1,1)'; mean(PARX2,1)'];
stdx2 = [std(PARX1)'; std(PARX2)'];
pval = pv(x2, stdx2);
Rout(1:2:end,3) = num2cell(x2);
Rout(2:2:end,3) = num2cell(stdx2);
stars2 = cellstr(star_sig(pval));
Rout(1:2:end,4) = stars2;