clear
clc
fnameinput = ('BALTIC.mat'); %wczytanie zmiennych
DATA = load(fnameinput);

n = 10000; % no. of draws in simluation


country = [DATA.dk, DATA.ee, DATA.fi, DATA.de, DATA.lv, DATA.lit, DATA.pl, DATA.ruc, DATA.se];
DATA.TCx = 2*(DATA.TC_km + DATA.TC_time/3);
DATA.TCx = DATA.TCx(DATA.ruo == 0);
% here choose appropriate quartile
DATA.TC = prctile(DATA.TCx, 75)*ones(length(DATA.ruo),1);
DATA.Edu_dummy = dummyvar(DATA.EDU);
DATA.HINC(DATA.ee == 1) = DATA.HINC(DATA.ee == 1)/15.9428;
DATA.HINC = DATA.HINC/1000;
DATA.HINC2 = DATA.HINC.^2;
DATA.age = DATA.age/10;
DATA.age2 = DATA.age.^2;
%DATA.bocc(DATA.bocc == -999) = 0;
DATA.envbn(~isnan(DATA.envbn)) = (DATA.envbn(~isnan(DATA.envbn)) - mean(DATA.envbn(~isnan(DATA.envbn))))/std(DATA.envbn(~isnan(DATA.envbn)));
DATA.envbn(isnan(DATA.envbn)) = mean(DATA.envbn(~isnan(DATA.envbn)));

DATA.X = [country, country.*DATA.TC(:,ones(9,1)),  DATA.envbn, DATA.MALE, DATA.HINC, DATA.HINC2, DATA.bocc];

DATA.Z = [country, DATA.envbn, DATA.MALE, DATA.HHKIDS, DATA.age, DATA.age2,DATA.Edu_dummy(:,2:4), DATA.bocc];
DATA.X = DATA.X(DATA.ruo == 0 & DATA.OUT == 0,:);
DATA.Z = DATA.Z(DATA.ruo == 0 & DATA.OUT == 0,:);
DATA.TRIPS0 = DATA.TRIPS == 0;
DATA.TRIPS0 = DATA.TRIPS0(DATA.ruo == 0 & DATA.OUT == 0);
DATA.TRIPS = DATA.TRIPS(DATA.ruo == 0 & DATA.OUT == 0);

%wczytanie parametrw
fnameinput = ('COEF.mat'); %wczytanie zmiennych
Param = load(fnameinput);

b = Param.b;
gammab = Param.gamma;
COV = Param.COV;
gammastd = Param.gammastd;

Adults = [4.266808,1.049334,4.214569,67.211949,1.631876,2.347624,30.518023,0.8*(941873+1716868+4879566)/1000000,7.379407]; % populacja
weight = Adults/sum(Adults,2);

% Calculating CS for one trip and its covariance matrix using delta method
tmp = diag(1./(b(10:18)).^2);
grad = zeros(9,23); 
grad(:,10:18) = tmp;
CS_var = grad*COV*grad';
CS = -1./b(10:18);

%random draws from B, CS and gamma
B = mvnrnd(b', COV, n);
%CSrnd = -1./B(:, 10:18); %- this is more proper, but leads to non-defined std for some variables
CSrnd = mvnrnd(CS', CS_var, n);
G = mvnrnd(gammab', diag(gammastd.^2),n);

CS_all = zeros(n,9);
CS_sim = zeros(n,9);
PARTIAL = zeros(n,9);
% Main loop - it may take some time 
for i = 1:n
    lambda = exp(DATA.X*B(i,:)');
    p = 1 - normcdf(DATA.Z*G(i,:)',0,1);
    fit = p.*lambda;
    mean_fit = [mean(fit(DATA.X(:,1) == 1)),mean(fit(DATA.X(:,2) == 1)),mean(fit(DATA.X(:,3) == 1)),mean(fit(DATA.X(:,4) == 1)),mean(fit(DATA.X(:,5) == 1)),mean(fit(DATA.X(:,6) == 1)),mean(fit(DATA.X(:,7) == 1)),mean(fit(DATA.X(:,8) == 1)),mean(fit(DATA.X(:,9) == 1))];
    CS_all(i, :) = mean_fit.*CSrnd(i,:);
    PARTIALx = fit*B(i,19) - normpdf(DATA.Z*G(i,:)',0,1).*lambda*G(i,10);
    PARTIAL(i,:) = [mean(PARTIALx(DATA.X(:,1) == 1)),mean(PARTIALx(DATA.X(:,2) == 1)),mean(PARTIALx(DATA.X(:,3) == 1)),mean(PARTIALx(DATA.X(:,4) == 1)),mean(PARTIALx(DATA.X(:,5) == 1)),mean(PARTIALx(DATA.X(:,6) == 1)),mean(PARTIALx(DATA.X(:,7) == 1)),mean(PARTIALx(DATA.X(:,8) == 1)),mean(PARTIALx(DATA.X(:,9) == 1))];
    fit = fit + PARTIALx;
    mean_fit = [mean(fit(DATA.X(:,1) == 1)),mean(fit(DATA.X(:,2) == 1)),mean(fit(DATA.X(:,3) == 1)),mean(fit(DATA.X(:,4) == 1)),mean(fit(DATA.X(:,5) == 1)),mean(fit(DATA.X(:,6) == 1)),mean(fit(DATA.X(:,7) == 1)),mean(fit(DATA.X(:,8) == 1)),mean(fit(DATA.X(:,9) == 1))];
    CS_sim(i, :) = mean_fit.*CSrnd(i,:);
end

% Second part of the Table 3
M = [mean(CS_all); prctile(CS_all, 2.5); prctile(CS_all, 97.5) ; prctile(CS_all, 0.5); mean(PARTIAL); prctile(PARTIAL, 2.5); prctile(PARTIAL, 97.5) ; prctile(PARTIAL, 0.5);...
    mean(CS_sim); prctile(CS_sim, 2.5); prctile(CS_sim, 97.5) ; prctile(CS_sim, 0.5) ];


last = [mean(sum(CS_all.*weight(ones(n,1),:),2)); prctile(sum(CS_all.*weight(ones(n,1),:),2), 2.5); prctile(sum(CS_all.*weight(ones(n,1),:),2), 97.5) ; prctile(sum(CS_all.*weight(ones(n,1),:),2), 0.5);...
    mean(sum(PARTIAL.*weight(ones(n,1),:),2)); prctile(sum(PARTIAL.*weight(ones(n,1),:),2), 2.5); prctile(sum(PARTIAL.*weight(ones(n,1),:),2), 97.5) ; prctile(sum(PARTIAL.*weight(ones(n,1),:),2), 0.5); ...
    mean(sum(CS_sim.*weight(ones(n,1),:),2)); prctile(sum(CS_sim.*weight(ones(n,1),:),2), 2.5); prctile(sum(CS_sim.*weight(ones(n,1),:),2), 97.5) ; prctile(sum(CS_sim.*weight(ones(n,1),:),2), 0.5)] ;
M = [M, last];
Adults = [Adults, sum(Adults,2)];
M = [Adults; M];
M([2:5, 10:13],:) = M([2:5, 10:13],:).*Adults(ones(8,1),:)/1000; 
M = [M; (M(10,:)- M(2,:));  (M(10,:)- M(2,:))./M(2,:)];